~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

TOMOYO Linux Cross Reference
Linux/tools/lib/bpf/Makefile

Version: ~ [ linux-6.12-rc7 ] ~ [ linux-6.11.7 ] ~ [ linux-6.10.14 ] ~ [ linux-6.9.12 ] ~ [ linux-6.8.12 ] ~ [ linux-6.7.12 ] ~ [ linux-6.6.60 ] ~ [ linux-6.5.13 ] ~ [ linux-6.4.16 ] ~ [ linux-6.3.13 ] ~ [ linux-6.2.16 ] ~ [ linux-6.1.116 ] ~ [ linux-6.0.19 ] ~ [ linux-5.19.17 ] ~ [ linux-5.18.19 ] ~ [ linux-5.17.15 ] ~ [ linux-5.16.20 ] ~ [ linux-5.15.171 ] ~ [ linux-5.14.21 ] ~ [ linux-5.13.19 ] ~ [ linux-5.12.19 ] ~ [ linux-5.11.22 ] ~ [ linux-5.10.229 ] ~ [ linux-5.9.16 ] ~ [ linux-5.8.18 ] ~ [ linux-5.7.19 ] ~ [ linux-5.6.19 ] ~ [ linux-5.5.19 ] ~ [ linux-5.4.285 ] ~ [ linux-5.3.18 ] ~ [ linux-5.2.21 ] ~ [ linux-5.1.21 ] ~ [ linux-5.0.21 ] ~ [ linux-4.20.17 ] ~ [ linux-4.19.323 ] ~ [ linux-4.18.20 ] ~ [ linux-4.17.19 ] ~ [ linux-4.16.18 ] ~ [ linux-4.15.18 ] ~ [ linux-4.14.336 ] ~ [ linux-4.13.16 ] ~ [ linux-4.12.14 ] ~ [ linux-4.11.12 ] ~ [ linux-4.10.17 ] ~ [ linux-4.9.337 ] ~ [ linux-4.4.302 ] ~ [ linux-3.10.108 ] ~ [ linux-2.6.32.71 ] ~ [ linux-2.6.0 ] ~ [ linux-2.4.37.11 ] ~ [ unix-v6-master ] ~ [ ccs-tools-1.8.12 ] ~ [ policy-sample ] ~
Architecture: ~ [ i386 ] ~ [ alpha ] ~ [ m68k ] ~ [ mips ] ~ [ ppc ] ~ [ sparc ] ~ [ sparc64 ] ~

Diff markup

Differences between /tools/lib/bpf/Makefile (Version linux-6.12-rc7) and /tools/lib/bpf/Makefile (Version linux-5.3.18)


  1 # SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-      1 # SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause)
  2 # Most of this file is copied from tools/lib/t      2 # Most of this file is copied from tools/lib/traceevent/Makefile
  3                                                     3 
  4 RM ?= rm                                       !!   4 BPF_VERSION = 0
  5 srctree := $(realpath $(srctree))              !!   5 BPF_PATCHLEVEL = 0
  6                                                !!   6 BPF_EXTRAVERSION = 4
  7 VERSION_SCRIPT := libbpf.map                   << 
  8 LIBBPF_VERSION := $(shell \                    << 
  9         grep -oE '^LIBBPF_([0-9.]+)' $(VERSION << 
 10         sort -rV | head -n1 | cut -d'_' -f2)   << 
 11 LIBBPF_MAJOR_VERSION := $(word 1,$(subst ., ,$ << 
 12 LIBBPF_MINOR_VERSION := $(word 2,$(subst ., ,$ << 
 13                                                     7 
 14 MAKEFLAGS += --no-print-directory                   8 MAKEFLAGS += --no-print-directory
 15                                                     9 
 16 # This will work when bpf is built in tools en !!  10 ifeq ($(srctree),)
 17 # isn't set and when invoked from selftests bu << 
 18 # is a ".". building_out_of_srctree is undefin << 
 19 # builds                                       << 
 20 ifndef building_out_of_srctree                 << 
 21 srctree := $(patsubst %/,%,$(dir $(CURDIR)))       11 srctree := $(patsubst %/,%,$(dir $(CURDIR)))
 22 srctree := $(patsubst %/,%,$(dir $(srctree)))      12 srctree := $(patsubst %/,%,$(dir $(srctree)))
 23 srctree := $(patsubst %/,%,$(dir $(srctree)))      13 srctree := $(patsubst %/,%,$(dir $(srctree)))
 24 #$(info Determined 'srctree' to be $(srctree))     14 #$(info Determined 'srctree' to be $(srctree))
 25 endif                                              15 endif
 26                                                    16 
 27 INSTALL = install                                  17 INSTALL = install
 28                                                    18 
 29 # Use DESTDIR for installing into a different      19 # Use DESTDIR for installing into a different root directory.
 30 # This is useful for building a package. The p     20 # This is useful for building a package. The program will be
 31 # installed in this directory as if it was the     21 # installed in this directory as if it was the root directory.
 32 # Then the build tool can move it later.           22 # Then the build tool can move it later.
 33 DESTDIR ?=                                         23 DESTDIR ?=
 34 DESTDIR_SQ = '$(subst ','\'',$(DESTDIR))'          24 DESTDIR_SQ = '$(subst ','\'',$(DESTDIR))'
 35                                                    25 
 36 include $(srctree)/tools/scripts/Makefile.arch     26 include $(srctree)/tools/scripts/Makefile.arch
 37                                                    27 
 38 ifeq ($(LP64), 1)                                  28 ifeq ($(LP64), 1)
 39   libdir_relative = lib64                          29   libdir_relative = lib64
 40 else                                               30 else
 41   libdir_relative = lib                            31   libdir_relative = lib
 42 endif                                              32 endif
 43                                                    33 
 44 prefix ?= /usr/local                               34 prefix ?= /usr/local
 45 libdir = $(prefix)/$(libdir_relative)              35 libdir = $(prefix)/$(libdir_relative)
 46 man_dir = $(prefix)/share/man                      36 man_dir = $(prefix)/share/man
 47 man_dir_SQ = '$(subst ','\'',$(man_dir))'          37 man_dir_SQ = '$(subst ','\'',$(man_dir))'
 48                                                    38 
 49 export man_dir man_dir_SQ INSTALL                  39 export man_dir man_dir_SQ INSTALL
 50 export DESTDIR DESTDIR_SQ                          40 export DESTDIR DESTDIR_SQ
 51                                                    41 
 52 include $(srctree)/tools/scripts/Makefile.incl     42 include $(srctree)/tools/scripts/Makefile.include
 53                                                    43 
 54 # copy a bit from Linux kbuild                     44 # copy a bit from Linux kbuild
 55                                                    45 
 56 ifeq ("$(origin V)", "command line")               46 ifeq ("$(origin V)", "command line")
 57   VERBOSE = $(V)                                   47   VERBOSE = $(V)
 58 endif                                              48 endif
 59 ifndef VERBOSE                                     49 ifndef VERBOSE
 60   VERBOSE = 0                                      50   VERBOSE = 0
 61 endif                                              51 endif
 62                                                    52 
 63 INCLUDES = -I$(or $(OUTPUT),.) \               !!  53 FEATURE_USER = .libbpf
 64            -I$(srctree)/tools/include -I$(srct !!  54 FEATURE_TESTS = libelf libelf-mmap bpf reallocarray cxx
                                                   >>  55 FEATURE_DISPLAY = libelf bpf
                                                   >>  56 
                                                   >>  57 INCLUDES = -I. -I$(srctree)/tools/include -I$(srctree)/tools/arch/$(ARCH)/include/uapi -I$(srctree)/tools/include/uapi
                                                   >>  58 FEATURE_CHECK_CFLAGS-bpf = $(INCLUDES)
                                                   >>  59 
                                                   >>  60 check_feat := 1
                                                   >>  61 NON_CHECK_FEAT_TARGETS := clean TAGS tags cscope help
                                                   >>  62 ifdef MAKECMDGOALS
                                                   >>  63 ifeq ($(filter-out $(NON_CHECK_FEAT_TARGETS),$(MAKECMDGOALS)),)
                                                   >>  64   check_feat := 0
                                                   >>  65 endif
                                                   >>  66 endif
                                                   >>  67 
                                                   >>  68 ifeq ($(check_feat),1)
                                                   >>  69 ifeq ($(FEATURES_DUMP),)
                                                   >>  70 include $(srctree)/tools/build/Makefile.feature
                                                   >>  71 else
                                                   >>  72 include $(FEATURES_DUMP)
                                                   >>  73 endif
                                                   >>  74 endif
 65                                                    75 
 66 export prefix libdir src obj                       76 export prefix libdir src obj
 67                                                    77 
 68 # Shell quotes                                     78 # Shell quotes
 69 libdir_SQ = $(subst ','\'',$(libdir))              79 libdir_SQ = $(subst ','\'',$(libdir))
 70 libdir_relative_SQ = $(subst ','\'',$(libdir_r     80 libdir_relative_SQ = $(subst ','\'',$(libdir_relative))
 71                                                    81 
                                                   >>  82 VERSION         = $(BPF_VERSION)
                                                   >>  83 PATCHLEVEL      = $(BPF_PATCHLEVEL)
                                                   >>  84 EXTRAVERSION    = $(BPF_EXTRAVERSION)
                                                   >>  85 
 72 OBJ             = $@                               86 OBJ             = $@
 73 N               =                                  87 N               =
 74                                                    88 
                                                   >>  89 LIBBPF_VERSION  = $(BPF_VERSION).$(BPF_PATCHLEVEL).$(BPF_EXTRAVERSION)
                                                   >>  90 
 75 LIB_TARGET      = libbpf.a libbpf.so.$(LIBBPF_     91 LIB_TARGET      = libbpf.a libbpf.so.$(LIBBPF_VERSION)
 76 LIB_FILE        = libbpf.a libbpf.so*              92 LIB_FILE        = libbpf.a libbpf.so*
 77 PC_FILE         = libbpf.pc                        93 PC_FILE         = libbpf.pc
 78                                                    94 
 79 # Set compile option CFLAGS                        95 # Set compile option CFLAGS
 80 ifdef EXTRA_CFLAGS                                 96 ifdef EXTRA_CFLAGS
 81   CFLAGS := $(EXTRA_CFLAGS)                        97   CFLAGS := $(EXTRA_CFLAGS)
 82 else                                               98 else
 83   CFLAGS := -g -O2                             !!  99   CFLAGS := -g -Wall
                                                   >> 100 endif
                                                   >> 101 
                                                   >> 102 ifeq ($(feature-libelf-mmap), 1)
                                                   >> 103   override CFLAGS += -DHAVE_LIBELF_MMAP_SUPPORT
                                                   >> 104 endif
                                                   >> 105 
                                                   >> 106 ifeq ($(feature-reallocarray), 0)
                                                   >> 107   override CFLAGS += -DCOMPAT_NEED_REALLOCARRAY
 84 endif                                             108 endif
 85                                                   109 
 86 # Append required CFLAGS                          110 # Append required CFLAGS
 87 override CFLAGS += -std=gnu89                  !! 111 override CFLAGS += $(EXTRA_WARNINGS)
 88 override CFLAGS += $(EXTRA_WARNINGS) -Wno-swit << 
 89 override CFLAGS += -Werror -Wall                  112 override CFLAGS += -Werror -Wall
                                                   >> 113 override CFLAGS += -fPIC
 90 override CFLAGS += $(INCLUDES)                    114 override CFLAGS += $(INCLUDES)
 91 override CFLAGS += -fvisibility=hidden            115 override CFLAGS += -fvisibility=hidden
 92 override CFLAGS += -D_LARGEFILE64_SOURCE -D_FI << 
 93 override CFLAGS += $(CLANG_CROSS_FLAGS)        << 
 94                                                << 
 95 # flags specific for shared library            << 
 96 SHLIB_FLAGS := -DSHARED -fPIC                  << 
 97                                                   116 
 98 ifeq ($(VERBOSE),1)                               117 ifeq ($(VERBOSE),1)
 99   Q =                                             118   Q =
100 else                                              119 else
101   Q = @                                           120   Q = @
102 endif                                             121 endif
103                                                   122 
104 # Disable command line variables (CFLAGS) over    123 # Disable command line variables (CFLAGS) override from top
105 # level Makefile (perf), otherwise build Makef    124 # level Makefile (perf), otherwise build Makefile will get
106 # the same command line setup.                    125 # the same command line setup.
107 MAKEOVERRIDES=                                    126 MAKEOVERRIDES=
108                                                   127 
109 all:                                              128 all:
110                                                   129 
111 OUTPUT ?= ./                                   << 
112 OUTPUT := $(abspath $(OUTPUT))/                << 
113 export srctree OUTPUT CC LD CFLAGS V              130 export srctree OUTPUT CC LD CFLAGS V
114 include $(srctree)/tools/build/Makefile.includ    131 include $(srctree)/tools/build/Makefile.include
115                                                   132 
116 SHARED_OBJDIR   := $(OUTPUT)sharedobjs/        !! 133 BPF_IN          := $(OUTPUT)libbpf-in.o
117 STATIC_OBJDIR   := $(OUTPUT)staticobjs/        !! 134 VERSION_SCRIPT  := libbpf.map
118 BPF_IN_SHARED   := $(SHARED_OBJDIR)libbpf-in.o << 
119 BPF_IN_STATIC   := $(STATIC_OBJDIR)libbpf-in.o << 
120 BPF_HELPER_DEFS := $(OUTPUT)bpf_helper_defs.h  << 
121 BPF_GENERATED   := $(BPF_HELPER_DEFS)          << 
122                                                   135 
123 LIB_TARGET      := $(addprefix $(OUTPUT),$(LIB    136 LIB_TARGET      := $(addprefix $(OUTPUT),$(LIB_TARGET))
124 LIB_FILE        := $(addprefix $(OUTPUT),$(LIB    137 LIB_FILE        := $(addprefix $(OUTPUT),$(LIB_FILE))
125 PC_FILE         := $(addprefix $(OUTPUT),$(PC_    138 PC_FILE         := $(addprefix $(OUTPUT),$(PC_FILE))
126                                                   139 
127 TAGS_PROG := $(if $(shell which etags 2>/dev/n !! 140 GLOBAL_SYM_COUNT = $(shell readelf -s --wide $(BPF_IN) | \
128                                                !! 141                            awk '/GLOBAL/ && /DEFAULT/ && !/UND/ {s++} END{print s}')
129 GLOBAL_SYM_COUNT = $(shell readelf -s --wide $ !! 142 VERSIONED_SYM_COUNT = $(shell readelf -s --wide $(OUTPUT)libbpf.so | \
130                            cut -d "@" -f1 | se << 
131                            sed 's/\[.*\]//' |  << 
132                            awk '/GLOBAL/ && /D << 
133                            sort -u | wc -l)    << 
134 VERSIONED_SYM_COUNT = $(shell readelf --dyn-sy << 
135                               sed 's/\[.*\]//' << 
136                               awk '/GLOBAL/ && << 
137                               grep -Eo '[^ ]+@    143                               grep -Eo '[^ ]+@LIBBPF_' | cut -d@ -f1 | sort -u | wc -l)
138                                                   144 
139 CMD_TARGETS = $(LIB_TARGET) $(PC_FILE)            145 CMD_TARGETS = $(LIB_TARGET) $(PC_FILE)
140                                                   146 
                                                   >> 147 CXX_TEST_TARGET = $(OUTPUT)test_libbpf
                                                   >> 148 
                                                   >> 149 ifeq ($(feature-cxx), 1)
                                                   >> 150         CMD_TARGETS += $(CXX_TEST_TARGET)
                                                   >> 151 endif
                                                   >> 152 
                                                   >> 153 TARGETS = $(CMD_TARGETS)
                                                   >> 154 
141 all: fixdep                                       155 all: fixdep
142         $(Q)$(MAKE) all_cmd                       156         $(Q)$(MAKE) all_cmd
143                                                   157 
144 all_cmd: $(CMD_TARGETS) check                     158 all_cmd: $(CMD_TARGETS) check
145                                                   159 
146 $(SHARED_OBJDIR) $(STATIC_OBJDIR):             !! 160 $(BPF_IN): force elfdep bpfdep
147         $(Q)mkdir -p $@                        << 
148                                                << 
149 $(BPF_IN_SHARED): force $(BPF_GENERATED) | $(S << 
150         @(test -f ../../include/uapi/linux/bpf    161         @(test -f ../../include/uapi/linux/bpf.h -a -f ../../../include/uapi/linux/bpf.h && ( \
151         (diff -B ../../include/uapi/linux/bpf.    162         (diff -B ../../include/uapi/linux/bpf.h ../../../include/uapi/linux/bpf.h >/dev/null) || \
152         echo "Warning: Kernel ABI header at 't    163         echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/bpf.h' differs from latest version at 'include/uapi/linux/bpf.h'" >&2 )) || true
153         @(test -f ../../include/uapi/linux/bpf    164         @(test -f ../../include/uapi/linux/bpf_common.h -a -f ../../../include/uapi/linux/bpf_common.h && ( \
154         (diff -B ../../include/uapi/linux/bpf_    165         (diff -B ../../include/uapi/linux/bpf_common.h ../../../include/uapi/linux/bpf_common.h >/dev/null) || \
155         echo "Warning: Kernel ABI header at 't    166         echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/bpf_common.h' differs from latest version at 'include/uapi/linux/bpf_common.h'" >&2 )) || true
                                                   >> 167         @(test -f ../../include/uapi/linux/netlink.h -a -f ../../../include/uapi/linux/netlink.h && ( \
                                                   >> 168         (diff -B ../../include/uapi/linux/netlink.h ../../../include/uapi/linux/netlink.h >/dev/null) || \
                                                   >> 169         echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/netlink.h' differs from latest version at 'include/uapi/linux/netlink.h'" >&2 )) || true
                                                   >> 170         @(test -f ../../include/uapi/linux/if_link.h -a -f ../../../include/uapi/linux/if_link.h && ( \
                                                   >> 171         (diff -B ../../include/uapi/linux/if_link.h ../../../include/uapi/linux/if_link.h >/dev/null) || \
                                                   >> 172         echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/if_link.h' differs from latest version at 'include/uapi/linux/if_link.h'" >&2 )) || true
156         @(test -f ../../include/uapi/linux/if_    173         @(test -f ../../include/uapi/linux/if_xdp.h -a -f ../../../include/uapi/linux/if_xdp.h && ( \
157         (diff -B ../../include/uapi/linux/if_x    174         (diff -B ../../include/uapi/linux/if_xdp.h ../../../include/uapi/linux/if_xdp.h >/dev/null) || \
158         echo "Warning: Kernel ABI header at 't    175         echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/if_xdp.h' differs from latest version at 'include/uapi/linux/if_xdp.h'" >&2 )) || true
159         $(SILENT_MAKE) -C $(srctree)/tools/bui !! 176         $(Q)$(MAKE) $(build)=libbpf
160         $(Q)$(MAKE) $(build)=libbpf OUTPUT=$(S << 
161                                                << 
162 $(BPF_IN_STATIC): force $(BPF_GENERATED) | $(S << 
163         $(SILENT_MAKE) -C $(srctree)/tools/bui << 
164         $(Q)$(MAKE) $(build)=libbpf OUTPUT=$(S << 
165                                                << 
166 $(BPF_HELPER_DEFS): $(srctree)/tools/include/u << 
167         $(QUIET_GEN)$(srctree)/scripts/bpf_doc << 
168                 --file $(srctree)/tools/includ << 
169                                                   177 
170 $(OUTPUT)libbpf.so: $(OUTPUT)libbpf.so.$(LIBBP    178 $(OUTPUT)libbpf.so: $(OUTPUT)libbpf.so.$(LIBBPF_VERSION)
171                                                   179 
172 $(OUTPUT)libbpf.so.$(LIBBPF_VERSION): $(BPF_IN !! 180 $(OUTPUT)libbpf.so.$(LIBBPF_VERSION): $(BPF_IN)
173         $(QUIET_LINK)$(CC) $(CFLAGS) $(LDFLAGS !! 181         $(QUIET_LINK)$(CC) --shared -Wl,-soname,libbpf.so.$(VERSION) \
174                 --shared -Wl,-soname,libbpf.so !! 182                                     -Wl,--version-script=$(VERSION_SCRIPT) $^ -lelf -o $@
175                 -Wl,--version-script=$(VERSION << 
176         @ln -sf $(@F) $(OUTPUT)libbpf.so          183         @ln -sf $(@F) $(OUTPUT)libbpf.so
177         @ln -sf $(@F) $(OUTPUT)libbpf.so.$(LIB !! 184         @ln -sf $(@F) $(OUTPUT)libbpf.so.$(VERSION)
                                                   >> 185 
                                                   >> 186 $(OUTPUT)libbpf.a: $(BPF_IN)
                                                   >> 187         $(QUIET_LINK)$(RM) $@; $(AR) rcs $@ $^
178                                                   188 
179 $(OUTPUT)libbpf.a: $(BPF_IN_STATIC)            !! 189 $(OUTPUT)test_libbpf: test_libbpf.cpp $(OUTPUT)libbpf.a
180         $(QUIET_LINK)$(RM) -f $@; $(AR) rcs $@ !! 190         $(QUIET_LINK)$(CXX) $(INCLUDES) $^ -lelf -o $@
181                                                   191 
182 $(OUTPUT)libbpf.pc:                               192 $(OUTPUT)libbpf.pc:
183         $(QUIET_GEN)sed -e "s|@PREFIX@|$(prefi    193         $(QUIET_GEN)sed -e "s|@PREFIX@|$(prefix)|" \
184                 -e "s|@LIBDIR@|$(libdir_SQ)|"     194                 -e "s|@LIBDIR@|$(libdir_SQ)|" \
185                 -e "s|@VERSION@|$(LIBBPF_VERSI    195                 -e "s|@VERSION@|$(LIBBPF_VERSION)|" \
186                 < libbpf.pc.template > $@         196                 < libbpf.pc.template > $@
187                                                   197 
188 check: check_abi check_version                 !! 198 check: check_abi
189                                                   199 
190 check_abi: $(OUTPUT)libbpf.so $(VERSION_SCRIPT !! 200 check_abi: $(OUTPUT)libbpf.so
191         @if [ "$(GLOBAL_SYM_COUNT)" != "$(VERS    201         @if [ "$(GLOBAL_SYM_COUNT)" != "$(VERSIONED_SYM_COUNT)" ]; then  \
192                 echo "Warning: Num of global s !! 202                 echo "Warning: Num of global symbols in $(BPF_IN)"       \
193                      "($(GLOBAL_SYM_COUNT)) do    203                      "($(GLOBAL_SYM_COUNT)) does NOT match with num of"  \
194                      "versioned symbols in $^     204                      "versioned symbols in $^ ($(VERSIONED_SYM_COUNT))." \
195                      "Please make sure all LIB    205                      "Please make sure all LIBBPF_API symbols are"       \
196                      "versioned in $(VERSION_S    206                      "versioned in $(VERSION_SCRIPT)." >&2;              \
197                 readelf -s --wide $(BPF_IN_SHA !! 207                 readelf -s --wide $(OUTPUT)libbpf-in.o |                 \
198                     cut -d "@" -f1 | sed 's/_v !! 208                     awk '/GLOBAL/ && /DEFAULT/ && !/UND/ {print $$8}'|   \
199                     sed 's/\[.*\]//' |         << 
200                     awk '/GLOBAL/ && /DEFAULT/ << 
201                     sort -u > $(OUTPUT)libbpf_    209                     sort -u > $(OUTPUT)libbpf_global_syms.tmp;           \
202                 readelf --dyn-syms --wide $(OU !! 210                 readelf -s --wide $(OUTPUT)libbpf.so |                   \
203                     sed 's/\[.*\]//' |         << 
204                     awk '/GLOBAL/ && /DEFAULT/ << 
205                     grep -Eo '[^ ]+@LIBBPF_' |    211                     grep -Eo '[^ ]+@LIBBPF_' | cut -d@ -f1 |             \
206                     sort -u > $(OUTPUT)libbpf_    212                     sort -u > $(OUTPUT)libbpf_versioned_syms.tmp;        \
207                 diff -u $(OUTPUT)libbpf_global    213                 diff -u $(OUTPUT)libbpf_global_syms.tmp                  \
208                      $(OUTPUT)libbpf_versioned    214                      $(OUTPUT)libbpf_versioned_syms.tmp;                 \
209                 rm $(OUTPUT)libbpf_global_syms    215                 rm $(OUTPUT)libbpf_global_syms.tmp                       \
210                    $(OUTPUT)libbpf_versioned_s    216                    $(OUTPUT)libbpf_versioned_syms.tmp;                   \
211                 exit 1;                           217                 exit 1;                                                  \
212         fi                                        218         fi
213                                                   219 
214 HDR_MAJ_VERSION := $(shell grep -oE '^$(pound) << 
215 HDR_MIN_VERSION := $(shell grep -oE '^$(pound) << 
216                                                << 
217 check_version: $(VERSION_SCRIPT) libbpf_versio << 
218         @if [ "$(HDR_MAJ_VERSION)" != "$(LIBBP << 
219                 echo "Error: libbpf major vers << 
220                      "'$(HDR_MAJ_VERSION)' !=  << 
221                 exit 1;                        << 
222         fi                                     << 
223         @if [ "$(HDR_MIN_VERSION)" != "$(LIBBP << 
224                 echo "Error: libbpf minor vers << 
225                      "'$(HDR_MIN_VERSION)' !=  << 
226                 exit 1;                        << 
227         fi                                     << 
228                                                << 
229 define do_install_mkdir                           220 define do_install_mkdir
230         if [ ! -d '$(DESTDIR_SQ)$1' ]; then       221         if [ ! -d '$(DESTDIR_SQ)$1' ]; then             \
231                 $(INSTALL) -d -m 755 '$(DESTDI    222                 $(INSTALL) -d -m 755 '$(DESTDIR_SQ)$1'; \
232         fi                                        223         fi
233 endef                                             224 endef
234                                                   225 
235 define do_install                                 226 define do_install
236         if [ ! -d '$(DESTDIR_SQ)$2' ]; then       227         if [ ! -d '$(DESTDIR_SQ)$2' ]; then             \
237                 $(INSTALL) -d -m 755 '$(DESTDI    228                 $(INSTALL) -d -m 755 '$(DESTDIR_SQ)$2'; \
238         fi;                                       229         fi;                                             \
239         $(INSTALL) $(if $3,-m $3,) $1 '$(DESTD !! 230         $(INSTALL) $1 $(if $3,-m $3,) '$(DESTDIR_SQ)$2'
240 endef                                             231 endef
241                                                   232 
242 install_lib: all_cmd                              233 install_lib: all_cmd
243         $(call QUIET_INSTALL, $(LIB_TARGET)) \    234         $(call QUIET_INSTALL, $(LIB_TARGET)) \
244                 $(call do_install_mkdir,$(libd    235                 $(call do_install_mkdir,$(libdir_SQ)); \
245                 cp -fpR $(LIB_FILE) $(DESTDIR)    236                 cp -fpR $(LIB_FILE) $(DESTDIR)$(libdir_SQ)
246                                                   237 
247 SRC_HDRS := bpf.h libbpf.h btf.h libbpf_common !! 238 install_headers:
248             bpf_helpers.h bpf_tracing.h bpf_en !! 239         $(call QUIET_INSTALL, headers) \
249             skel_internal.h libbpf_version.h u !! 240                 $(call do_install,bpf.h,$(prefix)/include/bpf,644); \
250 GEN_HDRS := $(BPF_GENERATED)                   !! 241                 $(call do_install,libbpf.h,$(prefix)/include/bpf,644); \
251                                                !! 242                 $(call do_install,btf.h,$(prefix)/include/bpf,644); \
252 INSTALL_PFX := $(DESTDIR)$(prefix)/include/bpf !! 243                 $(call do_install,libbpf_util.h,$(prefix)/include/bpf,644); \
253 INSTALL_SRC_HDRS := $(addprefix $(INSTALL_PFX) !! 244                 $(call do_install,xsk.h,$(prefix)/include/bpf,644);
254 INSTALL_GEN_HDRS := $(addprefix $(INSTALL_PFX) << 
255                                                << 
256 $(INSTALL_SRC_HDRS): $(INSTALL_PFX)/%.h: %.h   << 
257         $(call QUIET_INSTALL, $@) \            << 
258                 $(call do_install,$<,$(prefix) << 
259                                                << 
260 $(INSTALL_GEN_HDRS): $(INSTALL_PFX)/%.h: $(OUT << 
261         $(call QUIET_INSTALL, $@) \            << 
262                 $(call do_install,$<,$(prefix) << 
263                                                << 
264 install_headers: $(BPF_GENERATED) $(INSTALL_SR << 
265         $(call QUIET_INSTALL, libbpf_headers)  << 
266                                                   245 
267 install_pkgconfig: $(PC_FILE)                     246 install_pkgconfig: $(PC_FILE)
268         $(call QUIET_INSTALL, $(PC_FILE)) \       247         $(call QUIET_INSTALL, $(PC_FILE)) \
269                 $(call do_install,$(PC_FILE),$    248                 $(call do_install,$(PC_FILE),$(libdir_SQ)/pkgconfig,644)
270                                                   249 
271 install: install_lib install_pkgconfig install !! 250 install: install_lib install_pkgconfig
                                                   >> 251 
                                                   >> 252 ### Cleaning rules
                                                   >> 253 
                                                   >> 254 config-clean:
                                                   >> 255         $(call QUIET_CLEAN, config)
                                                   >> 256         $(Q)$(MAKE) -C $(srctree)/tools/build/feature/ clean >/dev/null
                                                   >> 257 
                                                   >> 258 clean:
                                                   >> 259         $(call QUIET_CLEAN, libbpf) $(RM) $(TARGETS) $(CXX_TEST_TARGET) \
                                                   >> 260                 *.o *~ *.a *.so *.so.$(VERSION) .*.d .*.cmd *.pc LIBBPF-CFLAGS
                                                   >> 261         $(call QUIET_CLEAN, core-gen) $(RM) $(OUTPUT)FEATURE-DUMP.libbpf
272                                                   262 
273 clean: fixdep-clean                            << 
274         $(call QUIET_CLEAN, libbpf) $(RM) -rf  << 
275                 *~ .*.d .*.cmd LIBBPF-CFLAGS $ << 
276                 $(SHARED_OBJDIR) $(STATIC_OBJD << 
277                 $(addprefix $(OUTPUT),         << 
278                             *.o *.a *.so *.so. << 
279                                                   263 
280 PHONY += force cscope tags check check_abi che !! 264 
                                                   >> 265 PHONY += force elfdep bpfdep
281 force:                                            266 force:
282                                                   267 
283 cscope:                                        !! 268 elfdep:
284         ls *.c *.h > cscope.files              !! 269         @if [ "$(feature-libelf)" != "1" ]; then echo "No libelf found"; exit 1 ; fi
285         cscope -b -q -I $(srctree)/include -f  !! 270 
286                                                !! 271 bpfdep:
287 tags:                                          !! 272         @if [ "$(feature-bpf)" != "1" ]; then echo "BPF API too old"; exit 1 ; fi
288         $(RM) -f TAGS tags                     << 
289         ls *.c *.h | xargs $(TAGS_PROG) -a     << 
290                                                   273 
291 # Declare the contents of the .PHONY variable     274 # Declare the contents of the .PHONY variable as phony.  We keep that
292 # information in a variable so we can use it i    275 # information in a variable so we can use it in if_changed and friends.
293 .PHONY: $(PHONY)                                  276 .PHONY: $(PHONY)
294                                                << 
295 # Delete partially updated (corrupted) files o << 
296 .DELETE_ON_ERROR:                              << 
297                                                << 
298 help:                                          << 
299         @echo 'libbpf common targets:'         << 
300         @echo '  HINT: use "V=1" to enable ver << 
301         @echo '  all     - build libraries and << 
302         @echo '  clean   - remove all generate << 
303         @echo '  check   - check ABI and versi << 
304         @echo ''                               << 
305         @echo 'libbpf install targets:'        << 
306         @echo '  HINT: use "prefix"(defaults t << 
307         @echo '        to adjust target destin << 
308         @echo '  install          - build and  << 
309         @echo '  install_headers  - install on << 
310         @echo ''                               << 
311         @echo 'libbpf make targets:'           << 
312         @echo '  tags    - use ctags to make t << 
313         @echo '  cscope  - use cscope to make  << 
                                                      

~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

kernel.org | git.kernel.org | LWN.net | Project Home | SVN repository | Mail admin

Linux® is a registered trademark of Linus Torvalds in the United States and other countries.
TOMOYO® is a registered trademark of NTT DATA CORPORATION.

sflogo.php